﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace WindowsApplication1
{
    public partial class imgPrueba : Form
    {
        Bitmap bmap;

        public imgPrueba()
        {
            InitializeComponent();
        }

        private void imgPrueba_Load(object sender, EventArgs e)
        {
            string path;

            path = System.IO.Path.GetDirectoryName(System.Reflection.Assembly.GetExecutingAssembly().GetName().CodeBase);
            path = string.Concat(path, "\\fotografo.bmp");

            char[] charBuf = path.ToCharArray();
            char[] charbuf2 = new char[path.Length - 6];

            for (int i = 6; i < path.Length; i++)
                charbuf2[i - 6] = charBuf[i];

            string ruta = "";
            ruta = new string(charbuf2);

            try
            {
                pictureBox1.Image = new Bitmap(ruta);
                bmap = new Bitmap(ruta);                          
            }

            catch { MessageBox.Show("no se encuentra el archivo");
            this.Close();
            }
        }

        private void button1_Click(object sender, EventArgs e)
        {            
                    Color pixel; int t;
                    float[] histograma;
                    float[] ecu; // tendrá el histograma acumulado
                    float t2;
                    int mayor, menor, mayor2 = 0;
                    Bitmap bn = new Bitmap(bmap.Width, bmap.Height);
            
                    pixel = bmap.GetPixel(0, 0);
                    t = (pixel.R + pixel.G + pixel.B) / 3;

                    mayor = t;
                    menor = mayor;

                    for (int y = 0; y < bmap.Height; y++)
                        for (int x = 0; x < bmap.Width; x++)
                        {
                            pixel = bmap.GetPixel(x, y);
                            t = (pixel.R + pixel.G + pixel.B) / 3;

                            if (t > mayor)
                                mayor = t;

                            if (t < menor)
                                menor = t;
                        }

                    if (menor >= 0)
                    {
                        histograma = new float[mayor+1];
                        ecu = new float[histograma.Length];
                    }

                    else
                    {
                        mayor2 = 0 - menor;
                        histograma = new float[mayor2 + mayor+1];
                        ecu = new float[histograma.Length]; 
                    }

            
                        for (int i = 0; i < histograma.Length; i++)
                        { histograma[i] = 0; ecu[i] = 0; }

            
                        for (int i = 0; i < bmap.Width; i++)
                            for (int j = 0; j < bmap.Height; j++)
                            {
                                pixel = bmap.GetPixel(i, j);
                                t = (pixel.R + pixel.G + pixel.B) / 3;
                                histograma[t]++;
                            }

                    for (int i = 0; i < histograma.Length; i++)
                         histograma[i]/= (bmap.Height * bmap.Width);

                    for (int i = 0; i < ecu.Length; i++)
                        for (int j = 0; j < i; j++)
                            ecu[i] = ecu[i] + histograma[j]; 

                    if (menor>=0)
                    
                    for (int i=0 ; i<bmap.Width ; i++)
                        for (int j = 0; j < bmap.Height; j++)
                        {
                            pixel = bmap.GetPixel(i, j);
                            t = (pixel.R + pixel.G + pixel.B) / 3;
                            t2 = ecu[t] * (mayor - menor) + menor;
                            bn.SetPixel(i, j, Color.FromArgb((int)t2,(int)t2,(int)t2)); 
                        }
  
                    else

                     for (int i = 0; i < bmap.Width; i++)
                         for (int j = 0; j < bmap.Height; j++)
                         {
                             pixel = bmap.GetPixel(i, j);
                             t = (pixel.R + pixel.G + pixel.B) / 3;
                             t2 = ecu[t + mayor2] * (mayor - menor) + menor;
                             bn.SetPixel(i, j, Color.FromArgb((int)t2, (int)t2, (int)t2)); 
                         }

                 pictureBox2.Image = bn;                  
        }

        private void imgPrueba_FormClosed(object sender, FormClosedEventArgs e)
        {

        }
    }
}